/*
Decoder.h - SMS Framework
Copyright (C) 2005, Tim Ellis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifdef __APPLE__
#import <Cocoa/Cocoa.h>
#else
#include <Foundation/Foundation.h>
#endif

@interface Decoder : NSObject {}

- (SMSObject*)decode:(NSString*)raw;
- (NSDictionary*)decodeFirstOctet:(NSString*)oct;
- (NSDictionary*)decodeMessage:(NSString*)raw senderAdLen:(int)al smscInfoLength:(int)se offset:(int)offset alphabet:(int)alpha;
- (NSString*)decodeService:(NSString*)raw smscInfoLength:(int)se;
- (NSString*)decodeSender:(NSString*)raw senderAdLen:(int)al smscInfoLength:(int)se;
- (NSString*)decodeMessageDec8bbin7bbin:(int)octhex eightBin:(NSString*)binsms;
- (NSString*)decodeMessage7BBin2Message:(NSString*)binMessage;
- (NSDate*)decodeTimestamp:(NSString*)raw senderAdLen:(int)al smscInfoLength:(int)se;
- (int)decodeToaNpi:(NSString*)octet;
- (int)decodeToaType:(NSString*)octet;
- (NSString*)decodeMessageHex2bin:(int)numOct hexString:(NSString*)hexStr;
- (int)decodePdufirstCheckTpmti:(NSString*)firstoctet;
- (int)decodeLength:(NSString*)raw offset:(int)theOffset;
- (NSString*)decodeHexOctet2Bin:(NSString*)raw offset:(int)theOffset;
- (NSDictionary*)decodeHeaderInformationMultipart:(NSString*)theHeader;
- (NSDictionary*)decodeTpDcs:(NSString*)raw offset:(int)theOffset;
- (int)decodeTpDcsMessageClass:(NSString*)octet;
- (int)decodeTpDcsIndicationType:(NSString*)octet;
- (int)decodeTpDcsIndicationActivity:(NSString*)octet;

@end
